program Zeitgleichung1; (* Compilieren mit Compiler-Flag "Graf"! *) (* 5. Mrz 2008 *)

uses
  Forms,
  WinTypes,
  Graphics,
  ExtCtrls,
  Types,
  KernGraf in 'c:\sources.del\KernGraf.pas',
  Kern2Graf in 'c:\sources.del\Kern2Graf.pas',
  ModulGraf in 'c:\sources.del\ModulGraf.pas',
  Eingabe in 'c:\sources.del\EINGABE.PAS' {EingabeDialog},
  Mathe in 'c:\sources.del\mathe.pas',
  AstrRout in 'c:\sources.del\Astrrout.pas',
  Planets1 in 'c:\sources.del\PLANETS1.PAS',
  FensterGraf in 'c:\sources.del\FensterGraf.pas',
  ModKugelDelphi in 'c:\sources.del\ModKugelDelphi.pas';

{$R *.RES}

const Titel = 'RahmenGraf';        (* Dieser Text wird in der Info-Box angezeigt: *)
      Version = '1.3';
      prDatum = '26.11.2003';
      inBitmap = true;
      Infotext = false;
      Startbild = false;
      Fontname = 'Courier';
      Fontsize = 10;
      Fontstyle = 0;

var Taste, BildNr: integer;
    Abbruch, Pause, Einzelschritt, init: boolean;
    Infodatei, Bildname, rStr: String;

procedure initGrafik;

   begin
   zCanvas:=Grundfenster.GrafikBMP.Canvas;
   zCanvas.Font:=Grundfenster.Canvas.Font;
   end;

var Durchlaeufe: integer;                (* ... zhlt die Schleifendurchlufe *)
(*
procedure Information;

   var tx: Text;
       s: String;

   begin
   if not DateiVorhanden(Infodatei) then Exit;
   Assign(tx, Infodatei); Reset(tx);
   GotoXY(0, zHoehe);
   while not eof(tx) do
      begin
      ReadLn(tx, s); WriteLn(s)
      end;
   end;
*)
(*procedure lgeheNach(x, y: real); far; {mit den Prozedurvariablen in ModKugelDelphi klappt's leider nicht!}

   begin
   geheNach(xPlot(x), yPlot(y))
   end;

procedure lzeichneLinie(x1, y1, x2, y2: real; f: integer); far;

   begin
   zeichneLinie(xPlot(x1), yPlot(y1), xPlot(x2), yPlot(y2), f)
   end;

procedure lzieheLinieNach(x, y: real; f: integer); far;

   begin
   zieheLinieNach(xPlot(x), yPlot(y), f)
   end;

procedure lzeichneGrafstring(x, y: real; s: String; f: integer); far;

   begin
   zeichneGrafstring(xPlot(x), yPlot(y), s, f)
   end;*)

const Datum0: Zeitpunkt = (Tag: 0; Monat: 1; Jahr: 2002);
      exakt = false;                  (* exakte Berechnung der Zeitgleichung? *)
      ProjWinkel = 0.0;

type bahndaten = RECORD
                    jd   : real;                     (* Referenzdatum *)
                    i    : real;                       (* Bahnneigung *)
                    kl   : real;                       (* Knotenlnge *)
                    omega: real;                      (* Perihellnge *)
                    m    : real;                   (* mittl. Anomalie *)
                    ex   : real;                     (* Exzentrizitt *)
                    my   : real;             (* mittl. tgl. Bewegung *)
                    a    : real;                   (* groe Halbachse *)
                    p    : real;
                    END;

var Schiefe, Exzentrizitaet, Rueckseite: boolean;
    SchiefeC, exzC, RueckseiteC: Char;
    i: integer;
    jd0, zg0, zg10, Mez, alphaS0, Summand: real;
    mA, exz, E: real;
    Erdbahn: Bahndaten;
    lambdal, vlambda, alphal, valpha, delta, zgl, Tageslaengel, Tageslaenge1l: real;
    Dx: Matrix;
    p1, p2: pVektor;

procedure Initialisierung;

   begin
   Infodatei:=Programmname+'.txt';
   Bildname:=Programmname;
(*   initGrafik;*)
   setzeVGAPalette;
   rStr:='1.0';
   init:=true;
   BildNr:=0;
   exzC:='j';
   SchiefeC:='j';
   RueckseiteC:='j';
   with Erdbahn do
      begin
      jd:=2447892.00000;
      i:=0.00000;
      kl:=0.00000;
      omega:=102.76844*Grad;
      m:=357.12769*Grad;
      ex:=0.01671;
      my:=0.98561*Grad;
      a:=1.0;
      p:=a*(1-ex*ex);
      end;
(*   ModKugel.geheNach:=lgeheNach;
   ModKugel.zeichneLinie:=lzeichneLinie;
   ModKugel.zieheLinieNach:=lzieheLinieNach;
   modKugel.setzeLinienbreite:=Kern2Graf.setzeLinienbreite;
   ModKugel.zeichneGrafstring:=lzeichneGrafstring;*)
   end;

function Zeitgl(Datum: Zeitpunkt; Mez: real): real;

   var y, L0, e, M, jh, Eklschiefe, ss, cs, zgl: real;

   begin
   jh:=julJahrhunderte(julDatum(Datum, Mez));
   berechneEkliptikschiefe(jh,Eklschiefe,ss,cs);
   if not Schiefe then
      begin
      Eklschiefe:=0.0; ss:=0.0; cs:=1.0
      end;
   y:=sqr(tan(0.5*Eklschiefe));
   L0:=(280.46645+jh*(36000.76983+jh*0.0003032))*Grad; (* mittlere Lnge der Sonne nach Meeus, S. 167 *)
   e:=0.016-jh*(0.000042037-jh*0.0000001236); (* Exzentrizitt der Erdbahn *)
   if not Exzentrizitaet then e:=0.0;
   M:=(357.52910+jh*(35999.05030-jh*(0.0001559+jh*0.00000048)))*Grad; (* mittlere Anomalie *)
   zgl:=y*sin(2.0*L0)-2.0*e*sin(M)+4.0*e*y*cos(2.0*L0)-0.5*sqr(y)*sin(4.0*
   L0)-1.25*sqr(e)*sin(2.0*M); (* nach Meeus, S. 192 *)
   while zgl>ZweiPi do zgl:=zgl-ZweiPi;
   Zeitgl:=zgl
   end;

function Keplergl(var E: real): real; far;

   begin
   Keplergl:=mA+exz*sin(E)-E;
   end;

function Keplergl1(var E: real): real; far;

   begin
   Keplergl1:=exz*cos(E)-1.0;
   end;

function alphaSonne(jd0, exErde, iErde: real): real;

   var nu, r, x, y, z, w, alpha, lambda: real;
       pErde: pVektor;

   begin
   if not Schiefe then iErde:=0.0;
   with Erdbahn do
      begin
      mA:=m+my*(jd0-jd);
      if Exzentrizitaet then exz:=exErde else exz:=0.0;
(*      E:=0.001;*)
      while mA>ZweiPi do mA:=mA-ZweiPi;
      E:=Nullstelle(KeplerGl, KeplerGl1, E, 0.001*Grad, 1000);
      nu:=2.0*arctan(sqrt((1.0+exz)/(1.0-exz))*tan(0.5*E));
      r:=p/(1.0+exz*cos(nu));
      w:=nu+omega-kl;
      x:=r*(cos(kl)*cos(w)-sin(kl)*sin(w)*cos(i));
      y:=r*(sin(kl)*cos(w)+cos(kl)*sin(w)*cos(i));
      z:=r*sin(w)*sin(i);              (* kart. Koord. bzgl. der Sonne *)
      end;
   with pErde do AstrRout.berechnePolarK(x, y, z, r, Laenge, Breite);
   lambda:=Pi+pErde.Laenge;
   if lambda>ZweiPi then lambda:=lambda-ZweiPi;
   vlambda:=(lambda-lambdal)/Grad;
   if vlambda<0.0 then vlambda:=vlambda+360.0;
   lambdal:=lambda;
   EclEqu(sin(iErde), cos(iErde), y, z);
   with pErde do AstrRout.berechnePolarK(x, y, z, r, Laenge, Breite);
   alpha:=Pi+pErde.Laenge;
   if alpha>ZweiPi then alpha:=alpha-ZweiPi;
   valpha:=(alpha-alphal)/Grad;
   if valpha<0.0 then valpha:=valpha+360.0;
   alphal:=alpha;
   delta:=-pErde.Breite;
   alphaSonne:=alpha
   end;

procedure zeichneHimmelskugel(alphaS, deltaS: real);

   var p: pVektor;
       r: rVektor;
       Dz, D: Matrix;

   begin
   setzeFuelltyp(255, weiss, weiss);
   fuelleRechteck(10, 500, 200, 200);
   setzeBildschirmausschnitt(10, 210, 500, 700);
   dimensioniereBildschirm(-1.0, 1.0, -1.0, 1.0);
   setzeTextausrichtung(1,0);
   if not Rueckseite
      then
         begin
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-1*zHoehe, 'Himmelskugel von auen', schwarz);
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-0*zHoehe, '(Mittagsblick von Sueden)', schwarz);
         end
      else
         begin
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-1*zHoehe, 'Himmelskugel von innen', schwarz);
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-0*zHoehe, '(Mittagsblick nach Sueden)', schwarz);
         end;
   VorderseiteDick:=false; RueckseiteDick:=false;
   if not Rueckseite
      then
         definierezDrehung(-alphaS, Dz)      (* ... damit die Sonne immer vorn ist *)
      else
         definierezDrehung(-alphaS+pi, Dz);      (* ... damit die Sonne immer hinten ist *)
   multipliziereMatrizen(Dx, Dz, D);
   zeichneKugel(D, 1.0, 15, 15, 5, schwarz);
   if not Rueckseite
      then
         begin
         VorderseiteDick:=true; RueckseiteDick:=false
         end
      else
         begin
         VorderseiteDick:=false; RueckseiteDick:=true
         end;
   zeichneBreitenkreis(D, 1.0, 0.0, 0, 360, 5, hellblau);          (* quator *)
   zeichneGrosskreis(D, 1.0, p1, p2, 5, rot, true);               (* Ekliptik *)
   if not Rueckseite
      then
         with p do begin r:=1.0; Laenge:=270*Grad; Breite:=deltaS end     (* Sonne *)
      else
         with p do begin r:=1.0; Laenge:=270*Grad-pi; Breite:=deltaS end;     (* Sonne *)
   Mathe.berechneCartK(p, r);
   dreherVektor(Dx, r);
   setzeFuelltyp(255, hellrot, hellrot);
   fuelleEllipse(xPlot(r[1]), yPlot(r[3]), 5, 5);
   setzeLinienbreite(3);
   zeichneLinie(xPlot(-1), yPlot(0), xPlot(1), yPlot(0), schwarz);
   end;

procedure zeichnegrHimmelskugel(alphaS, deltaS: real);

   var p: pVektor;
       r: rVektor;
       Dz, D: Matrix;

   begin
   setzeFuelltyp(255, weiss, weiss);
   fuelleRechteck(10, 500, 200, 200);
   setzeBildschirmausschnitt(xm-ym, xm, ym div 2, ym+ym div 2);
   dimensioniereBildschirm(-1.0, 1.0, -1.0, 1.0);
(*   loescheBildschirm;*)
   fuelleRechteck(xm-ym, ym div 2, ym, ym div 2);
   setzeTextausrichtung(1,0);
   if not Rueckseite
      then
         begin
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-1*zHoehe, 'Himmelskugel von auen', schwarz);
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-0*zHoehe, '(Mittagsblick von Sueden)', schwarz);
         end
      else
         begin
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-1*zHoehe, 'Himmelskugel von innen', schwarz);
         zeichneGrafstring(xPlot(0.0), yPlot(1.0)-5-0*zHoehe, '(Mittagsblick nach Sueden)', schwarz);
         end;
   VorderseiteDick:=false; RueckseiteDick:=false;
   if not Rueckseite
      then
         definierezDrehung(-alphaS, Dz)      (* ... damit die Sonne immer vorn ist *)
      else
         definierezDrehung(-alphaS+pi, Dz);      (* ... damit die Sonne immer hinten ist *)
   multipliziereMatrizen(Dx, Dz, D);
   setzeFuelltyp(255, hellgruen, hellgruen);
   if not Rueckseite then fuelleEllipse(xPlot(0.0), yPlot(0.0), xPlot(1.0)-xPlot(0.0), yPlot(1.0*sin(ProjWinkel*Grad))-yPlot(0));
   zeichneKugel(D, 1.0, 15, 15, 5, schwarz);
   setzeFuelltyp(255, hellgruen, hellgruen);
   if Rueckseite then fuelleEllipse(xPlot(0.0), yPlot(0.0), xPlot(1.0)-xPlot(0.0), yPlot(1.0*sin(ProjWinkel*Grad))-yPlot(0));
   if not Rueckseite
      then
         begin
         VorderseiteDick:=true; RueckseiteDick:=false
         end
      else
         begin
         VorderseiteDick:=false; RueckseiteDick:=true
         end;
   zeichneBreitenkreis(D, 1.0, 0.0, 0, 360, 5, hellblau);          (* quator *)
   zeichneGrosskreis(D, 1.0, p1, p2, 5, rot, true);               (* Ekliptik *)
   if not Rueckseite
      then
         with p do begin r:=1.0; Laenge:=270*Grad; Breite:=deltaS end     (* Sonne *)
      else
         with p do begin r:=1.0; Laenge:=270*Grad-pi; Breite:=deltaS end;     (* Sonne *)
   Mathe.berechneCartK(p, r);
   dreherVektor(Dx, r);
   setzeFuelltyp(255, hellrot, hellrot);
   fuelleEllipse(xPlot(r[1]), yPlot(r[3]), 5, 5);
   setzeLinienbreite(3);
   zeichneLinie(xPlot(-1), yPlot(0), xPlot(1), yPlot(0), schwarz);
   setzeFuelltyp(255, weiss, weiss);
   fuelleRechteck(xm-ym, yPlot(0), ym, ym div 2);
   end;

procedure Vorbereitung;

   begin
   i:=0;
   Mez:=0.0;
   jd0:=julDatum(Datum0, Mez);
   zg0:=Zeitgl(Datum0, Mez)/ZweiPi*24.0*60.0;
   zgl:=zg0;
   alphaS0:=alphaSonne(jd0, Erdbahn.ex, 23.5*Grad);
   zg10:=0.0;
   loescheBildschirm;
   waehleFont('Courier', 16, 1);
   setzeTextausrichtung(1,0);
   if Exzentrizitaet and Schiefe
      then zeichneGrafstring(xm div 2, 2*zHoehe, 'Zeitgleichung mit Exzentrizitt und mit Achsneigung', schwarz)
      else if Exzentrizitaet
              then zeichneGrafstring(xm div 2, 2*zHoehe, 'Zeitgleichung mit Exzentrizitt und ohne Achsneigung', schwarz)
              else if Schiefe
                      then zeichneGrafstring(xm div 2, 2*zHoehe, 'Zeitgleichung ohne Exzentrizitt und mit Achsneigung', schwarz)
                      else zeichneGrafstring(xm div 2, 2*zHoehe, 'Zeitgleichung ohne Exzentrizitt und ohne Achsneigung', schwarz);
   waehleFont('Courier', 10, 0);
   setzeTextausrichtung(0, 0);
   setzeLinienbreite(1);
   if not Rueckseite
      then
         begin
         definierexDrehung(-(40.0+ProjWinkel)*Grad, Dx);
         RueckseiteSichtbar:=false;
         end
      else
         begin
         definierexDrehung((40.0+ProjWinkel)*Grad, Dx);
         RueckseiteSichtbar:=true;
         end;
   VorderseiteSichtbar:=not RueckseiteSichtbar;                                             (* 2 Punkte auf der Ekliptik: *)
   with p1 do begin r:=1.0; Laenge:=270.0*Grad; Breite:=0.0*Grad end;
   with p2 do begin r:=1.0; Laenge:=0.0*Grad; if Schiefe then Breite:=23.5*Grad else Breite:=0.0 end;
   zeichneHimmelskugel(alphaS0, delta);
   setzeBildschirmausschnitt(250, xm-50, 50, ym-50);
(*   setzeBildschirmausschnitt(250, xm-50, 50, ym div 2-50);*)
   dimensioniereBildschirm(0.0, 366.0, -20.0, 20.0);
   setzeLinienbreite(1);
   zeichneXAchse(0.0, 0.0, 0.0, 366.0, 15.0, 3.0, 'Tage     ', schwarz, schwarz);
   zeichneYAchse(0.0, 0.0, -20.0, 20.0, 2.5, 1.0, 'Zeitgleichung in min', hellrot, hellrot);
   dimensioniereBildschirm(0.0, 366.0, -30.0, 30.0);
   zeichneYAchse(366.0, 0.0, -30.0, 30.0, 2.5, 1.0, '(Tageslnge-24h) in s', blau, blau);
(*   setzeLinienbreite(3);*)
   Durchlaeufe:=0;
   if Schiefe then Summand:=2.8 else Summand:=0.0; (* durch Ausprobieren gefunden *)
   Tageslaengel:=0.0; Tageslaenge1l:=0.0;
   geheNach(xPlot(i), yPlot(zg0));
   setzeTextausrichtung(0,0);
   zeichneGrafstring(0, ym-5, ' "e": Einzelschritt an/aus, "s": Bild speichern, "Esc": neue Eingabe, "Strg-C": Abbruch des Programms', hellrot);
   Einzelschritt:=true;
   end;

procedure parEingabe; far;

   begin
   if not Grundfenster.active then Exit;
   if not init then Initialisierung;
   Fenstertitel:='  Eingabe der Parameter';
   loescheBildschirm;
   Information(Infodatei, 'Courier', '3. Februar 2015', schwarz);
   liesChar('Exzentrizitt<>0 (j/n)?', exzC);
   Exzentrizitaet:=exzC in ['j','J'];
   liesChar('Ekliptikschiefe<>0 (j/n)?', SchiefeC);
   Schiefe:=SchiefeC in ['j','J'];
   liesChar('Soll die Innenseite der Himmelskugel dargestellt werden (j/n) ?', RueckseiteC);
   Rueckseite:=RueckseiteC in ['j','J'];
   Vorbereitung;
   started:=true; Abbruch:=false; Pause:=false;
   end;

procedure Ausgabe;

   var jd, zg, zg1, Tageslaenge, Tageslaenge1: real;
       Datum: Zeitpunkt;
       alphaS, alphaSm: real;
       s, s1: String;

   begin
   jd:=jd0+i;
   gregDatum(jd, Datum, Mez);
   zg:=Zeitgl(Datum, Mez)/ZweiPi*24.0*60.0;
   setzeBildschirmausschnitt(250, xm-50, 50, ym-50);
(*   setzeBildschirmausschnitt(250, xm-50, 50, ym div 2-50);*)
   dimensioniereBildschirm(0.0, 366.0, -20.0, 20.0);
   setzeLinienbreite(3);
   if exakt and (i>0) then zeichneLinie(xPlot(i-1), yPlot(zgl), xPlot(i), yPlot(zg), hellrot);
   zgl:=zg;
   alphaS:=alphaSonne(jd, Erdbahn.ex*1.0, 1.0*23.5*Grad);
   alphaSm:=alphaS0+Erdbahn.my*(jd-jd0);
   while alphaSm>ZweiPi do alphaSm:=alphaSm-ZweiPi;
   zg1:=-(alphaS-alphaSm)/Grad*4.0-Summand;
   if zg1>1000.0 then zg1:=zg1-1440;
   if zg10=0.0 then zg10:=zg1;
   if not exakt and (i>0) then zeichneLinie(xPlot(i-1), yPlot(zg10), xPlot(i), yPlot(zg1), hellrot);
   setzeLinienbreite(1);
   dimensioniereBildschirm(0.0, 366.0, -30.0, 30.0);
   if i=0 then zg0:=Zeitgl(Datum0, Mez)/ZweiPi*24.0*60.0;
   Tageslaenge:=(zg0-zg)*60;
   if (Tageslaengel=0.0) or (i=0) then Tageslaengel:=Tageslaenge;
   if exakt and (i>1) then zeichneLinie(xPlot(i-1), yPlot(Tageslaengel), xPlot(i), yPlot(Tageslaenge), blau);
   Tageslaengel:=Tageslaenge;
   zg0:=zg;
   Tageslaenge1:=(zg10-zg1)*60;
   if Tageslaenge1l=0.0 then Tageslaenge1l:=Tageslaenge1;
   if not exakt and (i<366) and (i>1) then zeichneLinie(xPlot(i-1), yPlot(Tageslaenge1l), xPlot(i), yPlot(Tageslaenge1), blau);
   Tageslaenge1l:=Tageslaenge1;
   zg10:=zg1;
   setzeTextausrichtung(0,0);
   Str(Datum.Tag:2, s); Str(Datum.Monat:2, s1); zeichneGrafstring(0, 180, '   Datum = '+s+'.'+s1+'.', schwarz);
   wandleZahlinString(  delta/Grad, 2.1, s); zeichneGrafstring(0, 200, '   delta ='+s+GradC, schwarz);
   wandleZahlinString(vlambda, 1.3, s); zeichneGrafstring(0, 220, ' vlambda ='+s+GradC+'/d', schwarz);
   wandleZahlinString( valpha, 1.3, s); zeichneGrafstring(0, 240, '  valpha ='+s+GradC+'/d', schwarz);
   wandleZahlinString(Erdbahn.my/Grad, 1.3, s); zeichneGrafstring(0, 260, ' valpham ='+s+GradC+'/d', schwarz);
   if i<366 then zeichneHimmelskugel(alphaS, delta);
   if i<366 then Inc(i) else i:=0;
   end;

procedure Pausenanfangprozedur;

   begin
   Info1Str:='Pausenanfang';
   Pause:=true;
   end;

procedure Pausenendeprozedur;

   begin
   Info1Str:=' "p": Pause, "Esc": Abbruch';
   Pause:=false
   end;

procedure Schleife; far;

   begin
   if not started then Start;
   if Abbruch or not started then Exit;
   if TasteGedrueckt then
      if Pause then
         begin
         Pausenendeprozedur; Taste:=Tastencode;
         end;
   if Pause or (Einzelschritt and not TasteGedrueckt) then Exit;
   Taste:=Tastencode;
   case Taste of
      Esc: begin
           Abbruch:=true;
           Info1Str:='Abbruch';
           Start;
           end;
      Ord('p'): Pausenanfangprozedur;
      Ord('e'): Einzelschritt:=not Einzelschritt;
      Ord('s'): begin
                Inc(BildNr);
                speichereBMP(Bildname+Chr(48+BildNr div 10)+Chr(48+BildNr mod 10)+'.bmp', 0, 0, xm, ym);
                end;
      end;
   Ausgabe;
   end;

begin (* Hauptprogramm *)
init:=false;
Application.CreateForm(TGrundfenster, Grundfenster);
  Application.CreateForm(TEingabeDialog, EingabeDialog);
  initProgram(inBitmap, Infotext, Startbild, Fontname, Fontsize, Fontstyle);

start:=parEingabe;
run:=Schleife;

Application.Run;                                (* Start der Programmschleife *)
end.
